!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 1996-2006, Thorstein Thorsteinsson                     *
!               1996-2006, David L. Cooper                             *
!***********************************************************************

subroutine makefile_cvb()

use casvb_global, only: ioffs, iprint, joffs, mustdeclare, ndep_ij, ndep_ji, nobj

implicit none

nobj = 0
ndep_ij = 0
ndep_ji = 0
ioffs(1) = 0
joffs(1) = 0
mustdeclare = .false.
iprint = 0

! Memory allocation:
call depend_cvb('MEM1','MEM0')
call depend_cvb('MEM2','MEM1')
call depend_cvb('MEM3','MEM2')
call depend_cvb('MEM4','MEM3')
call depend_cvb('MEM5','MEM4')
call depend_cvb('MEM6','MEM5')
call depend_cvb('MEM7','MEM6')
call depend_cvb('MEMORY','MEM7')

call decl_cvb('ORBS')
call decl_cvb('CVB')
call decl_cvb('ORBSTRY')
call decl_cvb('CVBTRY')

call depend_cvb('WFN','ORBS')
call depend_cvb('WFN','CVB')
call depend_cvb('WFNTRY','ORBSTRY')
call depend_cvb('WFNTRY','CVBTRY')

call depend_cvb('SVB','WFN')
call depend_cvb('EVB','WFN')
call depend_cvb('SVBTRY','WFNTRY')
call depend_cvb('EVBTRY','WFNTRY')

call depend_cvb('ORBFREE','MEM5')
call depend_cvb('CIFREE','MEM5')

call depend_cvb('ICONFS','MEM1')

call depend_cvb('GENDET','ICONFS')

call depend_cvb('SYMELM','MEM5')
call decl_cvb('PRSYMELM')

call depend_cvb('SYMINIT','MEM5')
call depend_cvb('SYMINIT','SYMELM')
call depend_cvb('ORBFREE','SYMINIT')

call depend_cvb('CONSTRUC','MEM5')
call depend_cvb('CONSTRUC','MEM3')
call depend_cvb('CONSTRUC','SYMELM')
call depend_cvb('CIFREE','CONSTRUC')

call depend_cvb('RDINT','MEM0')

call depend_cvb('RDCAS','MEM4')

call depend_cvb('OOHESS','MEM6')

call mkafter_cvb('SCALSTR','ICONFS')

! Starting guess is chosen:
! 1) As input guess if applicable.
! 2) Otherwise from "start" fileid, if applicable.
! 3) Otherwise from previous opt. step if applicable.
! 4) Otherwise semi-random (orbs)/perfect-pairing (cvb).
call touchdepend_cvb('GUESS','INPGS')
call touchdepend_cvb('GUESS','STRTGS')
call touchdepend_cvb('GUESS','RESTGS')
call untouch_cvb('INPGS')
call untouch_cvb('STRTGS')
call untouch_cvb('RESTGS')
call depend_cvb('ORBS','GUESS')
call depend_cvb('CVB','GUESS')
call depend_cvb('RESTGS','MEM2')

call mkafter_cvb('GUESS','SCALSTR')

call depend_cvb('TRWF','GUESS')
call depend_cvb('SYMINIT','TRWF')
call depend_cvb('CONSTRUC','TRWF')

call depend_cvb('SYMORBS','TRWF')
call depend_cvb('SYMORBS','SYMINIT')
call depend_cvb('SYMORBS','ORBS')

call depend_cvb('SYMCVB','TRWF')
call depend_cvb('SYMCVB','SYMINIT')

call depend_cvb('SYMCVB','CONSTRUC')
call depend_cvb('SYMCVB','CVB')

call depend_cvb('SYMWF','SYMORBS')
call depend_cvb('SYMWF','SYMCVB')

call touch_cvb('CASPRINT')
call touch_cvb('CNFPRINT')

call untouch_cvb('WRITEGS')

call decl_cvb('CASCHECK')

call mkafter_cvb('ICONFS','MEMORY')
call mkafter_cvb('GENDET','ICONFS')
call mkafter_cvb('SYMWF','GENDET')
call mkafter_cvb('RDINT','SYMWF')
call mkafter_cvb('RDCAS','RDINT')

call depend_cvb('INIT','MEMORY')
call depend_cvb('INIT','ICONFS')
call depend_cvb('INIT','GENDET')
call depend_cvb('INIT','SYMWF')
call depend_cvb('INIT','RDINT')
call depend_cvb('INIT','RDCAS')

call untouch_cvb('ORBPERM')
call depend_cvb('TRWF','ORBPERM')
call untouch_cvb('TRNSPN')
call depend_cvb('TRWF','TRNSPN')
call mkafter_cvb('TRNSPN','GUESS')
! Contents of CI vectors:
call depend_cvb('CI-ORBS','ORBS')
call depend_cvb('CI-CVB','CVB')
call depend_cvb('CI-ALL','MEM4')

call untouch_cvb('STAT')

call decl_cvb('PRTSUM')

return

end subroutine makefile_cvb
