!***********************************************************************
! This file is part of OpenMolcas.                                     *
!                                                                      *
! OpenMolcas is free software; you can redistribute it and/or modify   *
! it under the terms of the GNU Lesser General Public License, v. 2.1. *
! OpenMolcas is distributed in the hope that it will be useful, but it *
! is provided "as is" and without any express or implied warranties.   *
! For more details see the full text of the license in the file        *
! LICENSE or in <http://www.gnu.org/licenses/>.                        *
!                                                                      *
! Copyright (C) 2021, Jie J. Bao                                       *
!***********************************************************************

subroutine CMSRdMat(Mat,NRow,NCol,FileName,NameLen)

use Definitions, only: wp, iwp

implicit none
integer(kind=iwp), intent(in) :: NRow, NCol, NameLen
real(kind=wp), intent(out) :: Mat(NCol,NRow)
character(len=NameLen), intent(in) :: FileName
integer(kind=iwp) :: I, LU
integer(kind=iwp), external :: IsFreeUnit

LU = IsFreeUnit(33)
call Molcas_Open(LU,FileName)
do I=1,NRow
  read(LU,*) Mat(:,I)
end do
close(LU)

end subroutine CMSRdMat
